#include <SoftwareSerial.h>
#include <stdio.h>
//#include <Average.h>
#define SIN_2PI_16 0.38268343236508978
#define SIN_4PI_16 0.707106781186547460
#define SIN_6PI_16 0.923879532511286740
#define C_P_S_2PI_16 1.30656296487637660
#define C_M_S_2PI_16 0.54119610014619690
#define C_P_S_6PI_16 1.3065629648763766
#define C_M_S_6PI_16 -0.54119610014619690


SoftwareSerial mySerial(1, 2); 
int reading = 0;
int baseline = 0;
int baseline_filt = 0.01;

int value = 0;
int value_t_minus_1  = 0;
int value_t_minus_2  = 0;
int value_t_minus_3  = 0;
int value_t_minus_4  = 0;
int value_t_minus_5  = 0;
int value_t_minus_6  = 0;
int value_t_minus_7  = 0;
int value_t_minus_8  = 0;
int value_t_minus_9  = 0;
int value_t_minus_10 = 0;
int value_t_minus_11 = 0;
int value_t_minus_12 = 0;
int value_t_minus_13 = 0;
int value_t_minus_14 = 0;
int value_t_minus_15 = 0;

int smooth = 0;

int LED_PIN1 = 1; 

void setup() {
  CLKPR = (1 << CLKPCE);
  CLKPR = (0 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);
  ADMUX = (0 << REFS2) | (1 << REFS1) | (0 << REFS0) // 1.1V ref
    | (0 << MUX3) | (0 << MUX2) | (1 << MUX1) | (0 << MUX0); // PB4
  ADCSRA = (1 << ADEN) // enable
    | (1 << ADPS2) | (1 << ADPS1) | (0 << ADPS0); // prescaler /64

  pinMode(LED_PIN1, OUTPUT);  
  
  mySerial.begin(9600);

}


void R16SRFFT(float input[16],float output[16] ) {
  float temp, out0, out1, out2, out3, out4, out5, out6, out7, out8;
  float out9,out10,out11,out12,out13,out14,out15;

  out0=input[0]+input[8]; /* output[0 through 7] is the data that we */
  out1=input[1]+input[9]; /* take the 8 point real FFT of. */
  out2=input[2]+input[10];
  out3=input[3]+input[11];
  out4=input[4]+input[12];
  out5=input[5]+input[13];
  out6=input[6]+input[14];
  out7=input[7]+input[15];



  out8=input[0]-input[8];   /* inputs 8,9,10,11 are */
  out9=input[1]-input[9];   /* the Real part of the */
  out10=input[2]-input[10]; /* 4 point Complex FFT inputs.*/
  out11=input[3]-input[11]; 
  out12=input[12]-input[4]; /* outputs 12,13,14,15 are */
  out13=input[13]-input[5]; /* the Imaginary pars of  */
  out14=input[14]-input[6]; /* the 4 point Complex FFT inputs.*/
  out15=input[15]-input[7];

  /*First we do the "twiddle factor" multiplies for the 4 point CFFT */
  /*Note that we use the following handy trick for doing a complex */
  /*multiply:  (e+jf)=(a+jb)*(c+jd) */
  /*   e=(a-b)*d + a*(c-d)   and    f=(a-b)*d + b*(c+d)  */

  /* C_M_S_2PI/16=cos(2pi/16)-sin(2pi/16) when replaced by macroexpansion */
  /* C_P_S_2PI/16=cos(2pi/16)+sin(2pi/16) when replaced by macroexpansion */
  /* (SIN_2PI_16)=sin(2pi/16) when replaced by macroexpansion */
  temp=(out13-out9)*(SIN_2PI_16); 
  out9=out9*(C_P_S_2PI_16)+temp; 
  out13=out13*(C_M_S_2PI_16)+temp;
  
  out14*=(SIN_4PI_16);
  out10*=(SIN_4PI_16);
  out14=out14-out10;
  out10=out14+out10+out10;
  
  temp=(out15-out11)*(SIN_6PI_16);
  out11=out11*(C_P_S_6PI_16)+temp;
  out15=out15*(C_M_S_6PI_16)+temp;

  /* The following are the first set of two point butterfiles */
  /* for the 4 point CFFT */

  out8+=out10;
  out10=out8-out10-out10;

  out12+=out14;
  out14=out12-out14-out14;

  out9+=out11;
  out11=out9-out11-out11;

  out13+=out15;
  out15=out13-out15-out15;

  /*The followin are the final set of two point butterflies */
  output[1]=out8+out9;
  output[7]=out8-out9;

  output[9]=out12+out13;
  output[15]=out13-out12;
  
  output[5]=out10+out15;        /* implicit multiplies by */
  output[13]=out14-out11;        /* a twiddle factor of -j */                            
  output[3]=out10-out15;  /* implicit multiplies by */
  output[11]=-out14-out11;  /* a twiddle factor of -j */

  
  /* What follows is the 8-point FFT of points output[0-7] */
  /* This 8-point FFT is basically a Decimation in Frequency FFT */
  /* where we take advantage of the fact that the initial data is real*/

  /* First set of 2-point butterflies */
    
  out0=out0+out4;
  out4=out0-out4-out4;
  out1=out1+out5;
  out5=out1-out5-out5;
  out2+=out6;
  out6=out2-out6-out6;
  out3+=out7;
  out7=out3-out7-out7;

  /* Computations to find X[0], X[4], X[6] */
  
  output[0]=out0+out2;
  output[4]=out0-out2;
  out1+=out3;
  output[12]=out3+out3-out1;

  output[0]+=out1;  /* Real Part of X[0] */
  output[8]=output[0]-out1-out1; /*Real Part of X[4] */
  /* out2 = Real Part of X[6] */
  /* out3 = Imag Part of X[6] */
  
  /* Computations to find X[5], X[7] */

  out5*=SIN_4PI_16;
  out7*=SIN_4PI_16;
  out5=out5-out7;
  out7=out5+out7+out7;

  output[14]=out6-out7; /* Imag Part of X[5] */
  output[2]=out5+out4; /* Real Part of X[7] */
  output[6]=out4-out5; /*Real Part of X[5] */
  output[10]=-out7-out6; /* Imag Part of X[7] */

}

void loop() {
  float data[16];
  float output[16];
  float zero=0;
  ADCSRA |= (1 << ADSC);
  //
  // wait for completion
  //
  while (ADCSRA & (1 << ADSC))
    ;
  //
  // save result
  //
  reading = 256*ADCL + ADCH;
  baseline = baseline_filt*reading + (1-baseline_filt)*baseline;
  value = 0 + 2*(reading - baseline);

  data[0] = value;
  data[1] = value_t_minus_1;
  data[2] = value_t_minus_2;
  data[3] = value_t_minus_3;
  data[4] = value_t_minus_4;
  data[5] = value_t_minus_5;
  data[6] = value_t_minus_6;
  data[7] = value_t_minus_7;
  data[8] = value_t_minus_8;
  data[9] = value_t_minus_9;
  data[10] = value_t_minus_10;
  data[11] = value_t_minus_11;
  data[12] = value_t_minus_12;
  data[13] = value_t_minus_13;
  data[14] = value_t_minus_14;
  data[15] = value_t_minus_15;

  R16SRFFT(data,output);

//  int x0 =  output[0]; //DC component
  int x1 =  output[0]; // fractional frequency of +1/16
//  int x2 =  output[0]; // fractional frequency of +2/16
//  int x3 =  output[0]; // fractional frequency of +3/16
//  int x4 =  output[4]; // fractional frequency of +4/16
//  int x5 =  output[5]; // fractional frequency of +5/16
//  int x6 =  output[6]; // fractional frequency of +6/16
//  int x7 =  output[7]; // fractional frequency of +7/16
//  int x8 =  output[8]; //highest frequency
//  int x9 =  output[9]; // fractional frequency of +9/16
//  int x10 = output[10]; // fractional frequency of +10/16
//  int x11 = output[11]; // fractional frequency of +11/16
//  int x12 = output[12]; // fractional frequency of +12/16
//  int x13 = output[13]; // fractional frequency of +13/16
//  int x14 = output[14]; // fractional frequency of +14/16
//  int x15 = output[15]; // fractional frequency of +15/16

//  int sum = 0; 
//  sum = x0 + x1 + x2 + x3 + x4 + x5 + x6 + x7 + x8 + x9 + x10 + x11 + x12 + x13 + x14 + x15;
//  smooth = (value + value_t_minus_1 + value_t_minus_2 + value_t_minus_3 + value_t_minus_4 + value_t_minus_5 + value_t_minus_6 + value_t_minus_7 + value_t_minus_8 + value_t_minus_9 + value_t_minus_10 + value_t_minus_11 + value_t_minus_12 + value_t_minus_13 + value_t_minus_14 + value_t_minus_15)/16;
  mySerial.println(value);
//  mySerial.print(" ");
//  mySerial.println(x6);
//  mySerial.println(x1);
//  mySerial.print(" ");  
//  mySerial.println(smooth);
  
//  mySerial.print(value);
//  mySerial.print(" ");
//  mySerial.println(x5);


//digitalWrite(LED_PIN1, HIGH);
//delay(1000);                       
//digitalWrite(LED_PIN1, LOW);   
//delay(1000); 




if (value > 20000)
{
  digitalWrite(LED_PIN1, HIGH);   // turn the LED on (HIGH is the voltage level)
//  delay(10);                       
//  digitalWrite(LED_PIN1, LOW);   
//  delay(10); 
}
else{
  digitalWrite(LED_PIN1, LOW); 
}





//  space problems: won't work with sum?
//  gotta read that website with 16 point and see how to plot frequencies
  

  delay(1);

  value_t_minus_1  = value;
  value_t_minus_2  = value_t_minus_1;
  value_t_minus_3  = value_t_minus_2;
  value_t_minus_4  = value_t_minus_3;
  value_t_minus_5  = value_t_minus_4;
  value_t_minus_6  = value_t_minus_5;
  value_t_minus_7  = value_t_minus_6;
  value_t_minus_8  = value_t_minus_7;
  value_t_minus_9  = value_t_minus_8;
  value_t_minus_10 = value_t_minus_9;
  value_t_minus_11 = value_t_minus_10;
  value_t_minus_12 = value_t_minus_11;
  value_t_minus_13 = value_t_minus_12;
  value_t_minus_14 = value_t_minus_13;
  value_t_minus_15 = value_t_minus_14;
}














 




